/**
 *
 *  COLORS:       | HEX     |
 * ---------------+---------+
 *  light-blue    | #E2E4EF |
 * ---------------+---------+
 *  medium-blue   | #8892BF |
 * ---------------+---------+
 *  dark-blue     | #4F5B93 |
 * ---------------+---------+
 *
 */


html {
  background: #333 url('/images/bg-texture-00.svg');
  color: #CCC;
}
#layout-content {
  background:#F2F2F2;
  color:#333;
}
#layout-content:not(:only-child) {
  border-right:.25rem solid #666;
}

abbr {
  border-color: #8892BF;
}

h1, h2, h3, h4, h5, h6 {
  font-weight: 500;
  color:#333
}
header.title,
h1:after,
h2:after,
h3:after {
  display:table;
  width:100%;
  content:" ";
  margin-top:-1px;
  border-bottom:1px dotted;
}
.title h1:after,
.title h2:after,
.title h3:after {
  display:none;
}

a:link,
a:visited {
  color: #ccc;
}
#layout-content a:link,
#layout-content a:visited {
  color: #369;
}
a:hover,
a:focus,
#layout-content a:hover,
#layout-content a:focus {
  color: #AE508D;
  border-color: #AE508D;
  outline:0;
}


ul {
  list-style-type: disc;
}

ol {
  list-style-type: decimal;
}

dl.qandaentry {
  border-color:#000;
}

h1.refname {
  color: #793862;
}


.interfacename a,
.fieldsynopsis .type,
.methodsynopsis .type,
.constructorsynopsis .type {
  color:#693;
}

.classsynopsisinfo .modifier,
.fieldsynopsis .modifier,
.methodsynopsis .modifier,
.constructorsynopsis .modifier {
  color: #936;
}

.classsynopsis {
  color: #4D4D4D;
}

.docs .classsynopsisinfo_comment {
  color:#f80;
}

.title a,
.title {
  color: #793862;
}
.title time {
  color: #333;
}

.methodname b,
.methodname strong,
.methodname a,
.classsynopsis .classname,
.parameter {
    color: #369;
}

.initializer,
.initializer code {
  color:#936;
}

.dc-description {
  color:#737373;
}

/* {{{ Warnings, Tips and Notes */
#flash-message .success {
  background:#E6F2D9;
  border-color: #CCE6B3;
}
#flash-message .info,
div.tip {
  background:#D9E6F2;
  border-color: #B3CCE6;
  border-bottom-color:#9FBFDF;
}
blockquote.note {
  background-color: #E6E6E6;
  border-color: #ccc;
}
div.caution {
  background: #fcfce9;
  border-color: #e2e2d1;
}
.refsect1 blockquote.note {
  margin-left:0;
  background:#fff;
  border-color: #e5e6e9;
}
#flash-message .error,
div.warning {
  background:#F4DFDF;
  border-color: #EABFBF;
}

.docs .classsynopsis,
.refsect1 .fieldsynopsis,
.refsect1 .dc-description,
.docs .sect1 .dc-description,
div.tip,
blockquote.note,
div.caution,
div.warning {
  box-shadow:inset 0 0 0 1px rgba(0,0,0,.15);
  border-radius:0 0 2px 2px;
}
#flash-message .error a,
div.warning a:link,
div.warning a:visited,
div.warning h2,
div.warning h3 {
  color:#936;
}
#flash-message .success a,
#flash-message a:hover,
#flash-message a:focus,
div.warning a:hover,
div.warning a:focus {
  color:#693;
  border-color:#693;
}
/* }}} */


/* {{{ Navbar */
.navbar .nav > li > a:focus,
.navbar .nav > li > a:hover {
  color: #333333;
}
.navbar .nav > .active > a {
  box-shadow: inset 0 3px 8px rgba(0, 0, 0, 0.125);
}
.navbar .brand,
.navbar .nav > li > a {
  color: #E2E4EF;
  border:0;
  text-shadow: 0 -1px 0 rgba(0, 0, 0, 0.25);
}
.navbar .brand:hover,
.navbar .nav > li > a:hover,
.navbar .brand:focus,
.navbar .nav > li > a:focus {
  color: #fff;
}
.navbar .nav > li > a:focus,
.navbar .nav > li > a:hover {
  background-color: transparent;
  color: #fff;
}
.navbar .nav .active > a, 
.navbar .nav .active > a:hover,
.navbar .nav .active > a:focus {
  color: #fff;
  background-color: #4F5B93;
}
.navbar .navbar-search .search-query {
  background-color: #fff;
  color: #333;
  text-shadow: 0 1px 0 #fff;
  border:0;
  border-radius:2px;
  box-shadow: inset 0 1px 2px rgba(0,0,0,.2);
}
.navbar .navbar-search .search-query:focus {
  box-shadow: inset 0 1px 2px rgba(0,0,0,.2);
}
.navbar .navbar-search .search-query:-moz-placeholder {
  color: #999;
}
.navbar .navbar-search .search-query:-ms-input-placeholder {
  color: #999;
}
.navbar .navbar-search .search-query::-webkit-input-placeholder {
  color: #999;
}
.navbar {
  border-color:#4F5B93;
  background:#8892BF;
  box-shadow: 0 .25em .25em  rgba(0,0,0,.1);
}
.navbar .brand {
  color: #fff;
}
.navbar a {
  text-shadow: 0 1px 0 #fff;
}

/* }}} */


/* {{{ User notes */
#usernotes .count {
  background-color: #793862;
  color: #fff;
  border-radius: 4px;
}
#usernotes .note .name {
  color: #333;
}
#usernotes .note .date {
  color: #666;
}
#usernotes .note .name:hover + .genanchor {
  color: black;
}
#usernotes .note .text {
  transition: opacity 0.4s;
}
#usernotes .note .votes .tally {
  color: #333;
}
#usernotes .note .votes a {
  transition: border 0.4s;
}
/* }}} */


/* {{{ Tables */
.doctable,
.segmentedlist {
  border-color: #ccc;
}
.doctable thead tr,
.segmentedlist thead tr {
  border-color: #C4C9DF;
  border-bottom-color: #8892BF;
  color: #333;
}
.doctable th,
.segmentedlist th {
  background-color: #C4C9DF;
}
.doctable tr,
.segmentedlist tr {
  border-color: #ccc
}
.doctable tbody tr:nth-child(odd),
.segmentedlist tbody tr:nth-child(odd) {
  background-color: #ffffff;
}
.doctable tbody tr:nth-child(even),
.segmentedlist tbody tr:nth-child(even) {
  background-color: #E6E6E6;
}
/* }}} */


/* {{{ Syntax highlighting (and other similar boxes) */
#usernotes .note .text,
.example-contents > [class$="code"],
.example-contents.screen,
.informalexample .literallayout {
  background-color: #FFF;
  box-shadow: inset 0 0 0 1px rgba(0,0,0,.15);
  border-radius: 0 0 2px 2px;
}
.refsect1 .example-contents > [class$="code"],
.refsect1 .example-contents.screen {
  background-color: #fff;
}
.docs .classsynopsis,
.refsect1 .fieldsynopsis,
.refsect1 .dc-description,
.docs .sect1 .dc-description {
    background:#fff;
    border-color: #d9d9d9;
}
.phpcode span.html {
  color: black;
  background-color: transparent;
}
.phpcode span.comment {
  color: #4F5B93;
  background-color: transparent;
}
div.phpcode span.default {
  color: #369;
  background-color: transparent;
}
div.phpcode span.keyword {
  color: #693;
  background-color: transparent;
}
div.phpcode span.string {
  color: #c33;
  background-color: transparent;
}

.para var,
.simpara var
{
  background-color: #E6E6E6;
  border-radius: 2px;
  color: #333;
  padding: 2px 4px;
  white-space: nowrap;
  font-style: normal;
  font: normal 14px / 1.46 "Source Code Pro", monospace; 
}

var.reset
{
  background: none !important;
  padding: 0 !important;
  font-size: 1em !important;
}
/* }}} */



/* {{{ The anchor for section headers */
#layout-content a.genanchor:link,
#layout-content a.genanchor:visited {
    color: transparent;
    border-bottom: none;
}
#layout-content a.genanchor:hover,
#layout-content a.genanchor:focus {
    color: #333;
    border-bottom: none;
}
/* }}} */


.warn {
  border-color: #4F5B93;
  background-color: #fff;
  border-radius: 0 0 2px 2px;
}

pre.info {
  background-color: #efefef;
  border-color: #ddd;
}

aside.tips div.border {
    display:none;
}
aside.tips h3 {
  color:#E6E6E6;
}
aside.tips a {
  color:#ccc;
  border-bottom:1px dotted #666;
}
aside.tips .panel > a:after,
aside.tips .panel > span:after {
  content:" ";
  display:block;
  border-bottom:1px dotted #666;
}
aside.tips .panel > a:hover:after {
  border-color:#AE508D;
}
aside.tips a:hover,
aside.tips a:focus {
  color:#AE508D;
  border-color:#AE508D;
}

.soft-deprecation-notice {
  color: #333;
  border-color: #eecdde;
  background-color: #f9ecf2;
}
.soft-deprecation-notice h1.title {
  color: #454e55;
}
.soft-deprecation-notice blockquote.sidebar {
  color: #660000;
  border-color: #660;
}


/* {{{ Breadcrumbs */
#breadcrumbs {
    color: #999;
}
/* }}} */


/* {{{ Layout menu Left-hand sidebar */
.layout-menu ul.child-menu-list li:first-child a {
  border-top-color:#666;
}
.layout-menu ul.child-menu-list li.current a {
  color:#AE508D;
  border-bottom-color:#AE508D;
}
.layout-menu ul.child-menu-list a {
  border-color: #666;
}
/* }}} */


/* {{{ ElePHPants */
div.elephpants img {
  opacity: 0.5;
  transition: all 0.2s ease-in-out;
  -webkit-transition: all 0.2s ease-in-out;
  -moz-transition: all 0.2s ease-in-out;
}
div.elephpants:hover img {
  opacity: 0.6;
  transition: all 0.2s ease-in-out;
  -webkit-transition: all 0.2s ease-in-out;
  -moz-transition: all 0.2s ease-in-out;
}
div.elephpants img:hover,
div.elephpants img:focus {
  opacity: 1;
}
/* }}} */


.mirror {
	position: relative;
	border: 1px solid #ccc;
	padding: 20px;
	margin: 5px;
}
.mirror .title img {
	position: absolute;
	right: 0px;
}
.mirror .title {
	font-size: 1.4em;
	position: relative;
}

.headsup {
  padding:.25rem 0;
  height:1.5rem;
  border-bottom:.125rem solid #696;
  background-color: #9c9;
  color:#fff;
}

.headsup,
.headsup a {
  margin: 0 auto;
  text-align: center;
  color: #fff;
}

/* vim: set ts=2 sw=2 et: */
